#include <stdio.h>
#include <stdlib.h>

typedef struct pacijent
{
    int k_jedinica;
    char k_grupa;
} Pacijent;

int main()
{
 Pacijent* covek;
    int n,i, zalihe_O, zalihe_A, zalihe_B, zalihe_AB;
    scanf ("%d",&n);
    scanf ("%d %d %d %d",&zalihe_O,&zalihe_A,&zalihe_B,&zalihe_AB);
    for (i=0;i<n;i++)
    {
    scanf("%s",&covek->k_grupa);
    scanf("%d",&covek->k_jedinica);
    }
        if (covek->k_grupa='O')
        {
            if(covek->k_jedinica > zalihe_O)
        {
            printf("nemoguce");
            exit(0);
        }
        else zalihe_O=zalihe_O-covek->k_jedinica;
        }
        if (covek->k_grupa='A')
        {
            if (covek->k_jedinica >zalihe_A)
            {
                if (covek->k_jedinica >zalihe_O)
                {
                   printf("nemoguce");
                    exit(0);
                }
                else zalihe_O=zalihe_O-covek->k_jedinica;
            }
            else zalihe_A=zalihe_A-covek->k_jedinica;
        }
        if (covek->k_grupa='B')
        {
            if (covek->k_jedinica >zalihe_B)
            {
                if (covek->k_jedinica >zalihe_O)
                {
                   printf("nemoguce");
                    exit(0);
                }
                else zalihe_O=zalihe_O-covek->k_jedinica;
            }
            else zalihe_B=zalihe_B-covek->k_jedinica;
        }
        if (covek->k_grupa='AB');
        {
            if (covek->k_jedinica >zalihe_AB)
            {
                if (covek->k_jedinica >zalihe_A)
                {
                    if(covek->k_jedinica >zalihe_B)
                    {
                        if(covek->k_jedinica > zalihe_O)
                    {
                   printf("nemoguce");
                    exit(0);
                    }
                else zalihe_O=zalihe_O-covek->k_jedinica;
            }
            else zalihe_B=zalihe_B-covek->k_jedinica;
                }
        else zalihe_A=zalihe_A-covek->k_jedinica;
        }
        zalihe_AB=zalihe_AB-covek->k_jedinica;
    }
    printf ("moguce \n");
    printf ("%d %d %d %d",zalihe_O,zalihe_A,zalihe_B,zalihe_AB);
    return 0;

}